<?php
/*
* Copyright (c) 2007, Dustin Spicuzza <dustin@virtualroadside.com>
* All rights reserved.
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * Neither the name of Dustin Spicuzza nor the
*       names of any contributors may be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY DUSTIN SPICUZZA AND CONTRIBUTORS ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


?><html>
<head>
	<title>PHPExec v0.1</title>
	<style type="text/css">
	pre{color: #000000; padding: 0.5em; border: 1px dotted #000000; background: #efefef;}
	</style>
<body>
<h4>phpExec v0.1</h4>
<pre>
<?php

echo date("F j, Y, g:i:s a\n\n");

function main_fn(){
	
	$files = array('phpexec','netcat','phpexec.sh');
	$ssh_file = 'id_rsa';	// ssh key file
	
	// sanity checks
	foreach ($files as $file)
		if (!file_exists($file))
			return "File $file does not exist! Cannot continue.";
		else if (!is_executable($file) && !@chmod($file,0700))
			return "Cannot change file permissions on $file, and file is not executable! This means phpexec probably will not work!";
	
	if (!file_exists($ssh_file) || !is_readable($ssh_file))
		return "SSH key file does not exist! Cannot continue.";

	// ssh key file CANNOT be world or group readable
	$x = @stat($ssh_file);
	if (($x[2] & 00077) && !@chmod($ssh_file,0600))
		return "SSH key file $ssh_file needs to have the proper permissions on it (600)!";
		
	// execute the program
	passthru("./phpexec");

	return "";
}


function _file_put_contents($filename,$contents) {

	if (!@touch($filename) || !@chmod($filename,600) || !($handle = @fopen($filename,"wb")))
		return false;
	
	fwrite($handle,$contents);
	fclose($handle);
    return true;
}

$msg = main_fn();
if ($msg != "")
	$msg = 'Error: ' . $msg;
echo $msg;


?>
</pre>
<hr/>
<address>&copy; 2007 Dustin Spicuzza</address>
</body></html>
